     /*
        Scanmail - send any unsent echomail messages to our feeds
        and any new netmail to the correct (routed) system.
        This program is equivalent to Jans QSCAN and SCANMAIL combined.
        Alternatively, if exec'd with a command line of more than just
        line number, rescan one area from a given message, to either one
        or all feeds. Command line is "linenr areanr numtoscan onefeed"
        V1.17 adds a third mode. If the second parameter is "net" then
        scanmail will scan netmail only. This is intended for use by
        the mailer when responding to areamgr requests.
     */
#include <stdio.h>
#include <stdlib.h>
#include <qdos.h>
#include <qptr.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <csrvthg.h>
#include <database.h>
#include <stdarg.h>
#include <time.h>
#include <sys/stat.h>

#define unixtoql 283996800              /* time conversion, 1970 to 1961 */

#undef _condetails
#define LINES   14
#define COLUMNS 52
#define BORDERW 1
struct WINDOWDEF
     _condetails = {
        2,
        BORDERW,
        0,
        7,
        6*COLUMNS+4*BORDERW,
        10*LINES+3*BORDERW+12,
        16,
        26
        };

void    consetup_title();
void    (*_consetup)() = consetup_title;
char*   _endmsg = NULL;

#define BMAX 42
#define AMAX 80

char _prog_name[] = "Pbox Scanmail";
char _version[]   = "1.17";
char _copyright[] = "PA Borman";

   struct list
    {
        unsigned short net;     /* net number */
        unsigned short node;    /* node number */
        struct list *next_ptr;  /* pointer to next element */
    };

struct list *seen_ptr = NULL;   /* no 'seen' list yet */
struct list *path_ptr = NULL;   /* no 'path' list either */
struct list *feed_ptr = NULL;   /* no 'feed' list */

char    inbound[BMAX+2], outbound[BMAX+2] ,mareas[BMAX+2], areaname[BMAX+2],
        routing[BMAX+2], feeddbs[BMAX+2], zipper[BMAX+2], scanlog[BMAX+2],
        network[36], logmsg[102], pointnet[BMAX+2], tempdir[BMAX+2],
        scancmd[BMAX+2],  msgtext[32002], atype[6], sysdir[BMAX+2],
        onefeed[36];

unsigned short myzone = 0,mynet = 0,mynode = 0,mypoint = 0,myfake = 0;
struct tm *now;
long  rnum;
short capable = 0x0001;
FILE  *lg;
long  total = 0;                   /* number of exported messages */
int     scancount = -1;
int     onearea = -1;
char  line  = 0;
char  rescan = 0;

/*  forward declarations  */
void    log       (char *s);                    /* print msg to scr & log */
void    sysvar    (char *v, char *a, int s);    /* get system variable */
void    netmail   (long);                       /* process netmail area */
void    echomail  (long, char *);               /* process echomail area */
int     export    (long d, char *l);            /* export msg to feeds */
char  * addline   (struct list **l, char *p, int t);
void    free_list (struct list *l);
int     insert    (struct list **l, unsigned short n, unsigned short d);
int     append    (struct list **l, unsigned short n, unsigned short d);
void    outword   (long d, short f, FILE *c);
void    add_to_packets(FILE *c, char *a, char *n);
int     add_feeds (char *f,unsigned short n);
void    intel     (FILE *f, int n);
int     myaddress (unsigned short z,unsigned short n,unsigned short d,unsigned short p);
int     copyfile  (char *s, char *t);  /* copy file */


/*---------------------------------------------------------------------------*/
short htos(char *ptr)   /* convert ascii hex word to a short */
{
short val = 0;
char  c,f;

 for(f = 1; f <5; f++)
 {
   c = *ptr;
   switch (c)
   {
     case '0': case '1': case '2': case '3': case '4':
     case '5': case '6': case '7': case '8': case '9':
       c -= '0';
       break;
     case 'a': case 'b': case 'c': case 'd': case 'e': case 'f':
       c -= 'a';
       c += 10;
       break;
     case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
       c -= 'A';
       c += 10;
       break;
   }
   val *= 16;
   val += c;
   ptr++;
 }
 return(val);
}
/*---------------------------------------------------------------------------*/
short readword(FILE *fp)        /* fido stores in INTEL format ;-((          */
{
  int a,b;
  a= fgetc(fp);
  b= fgetc(fp);
  return (short)(a+(256*b));
}
/*---------------------------------------------------------------------------*/
int  main(int argc, char * argv[])
{
int     n = -1;                 /* server flag */
int     f;                      /* 'for' loop counter */
short   ans;                    /* reply from fsd_xxx functions */
long    adbid = -1;             /* area database dbid */
long    aflch = -1;             /* and channel ID */
char    feeds[402];             /* ascii list of feeds */
struct  qdirect qd;             /* structure for reading directories */
chanid_t dirch;                 /* directory channel */
char    temp[40];
char    pktname[40];
char    newname[40];
char    attname[40];
char    arcname[40];
char    cmdline[100];
int     namelen,newzip;
char    day[4];
char    *name_ptr;
long    ferr,ziptime,zipchan;
char    *tokptr;
char    *tptr;
unsigned short tn,td;
FILE    *fp;
char    netonly = 0;

 onefeed[0] = '\0';
 if(argc >= 2)                  /* get line number if supplied */
   line = (char)atoi(argv[1]);
 else
   line = 0;
 if(argc >= 3)
 {
   if(strcmp("net", argv[2]) == 0)
     netonly = 1;
   else
   {
     onearea = atoi(argv[2]);
     rescan = 1;
   }
 }
 if(argc >= 4)
   scancount = atoi(argv[3]);
 if(argc >= 5)
   (void)strcpy(onefeed,argv[4]);

 if((n=UseSrvThg (CLNT, "pbox")) == 0)
 {
   sysvar("scanlog",scanlog,BMAX);
   sysvar("outbound",outbound,BMAX);
   sysvar("inbound",inbound,BMAX);
   sysvar("sysdir",sysdir,BMAX);
   sysvar("tempdir",tempdir,BMAX);
   sysvar("mareas",mareas,BMAX);
   sysvar("netroute",routing,BMAX);
   sysvar("feeds",feeddbs,BMAX);
   sysvar("zip_prg",zipper,BMAX);
   sysvar("scanzip_cmd",scancmd,BMAX);

   if(scanlog[0] != '-')
     lg = fopen(scanlog, "a");    /* open or create logfile */
   else
     lg = NULL;                   /* flag if no log required */

   rnum = mt_rclck();             /* 'unique' number seed */
   ferr = rnum;                   /* and also ql time     */
   ferr -= unixtoql;              /* in unix base (1961)  */
   now = localtime(&ferr);        /* fill time structure  */
   (void)strftime(temp, 39,       /* turn into ascii string */
         "\n%a %d %b %y %H:%M:%S", now);
   log(temp);
   (void)strncpy(day,&temp[1],3);  /* get day name */
   day[1] = (char)toupper(day[1]); /* make Tue -> TUe */
   day[2] = '0';                   /* make TUe -> TU0 */
   day[3] = '\0';                  /* short length, 3 chars day, NULL */

   if (rescan)
   {
     (void)sprintf(temp,"Rescan %d messages, area %d, to %s",
                   scancount, onearea, onefeed);
     log(temp);
   }
   if (netonly)
   {
     log("Scanning netmail");
   }
   aflch = io_open( mareas, 1 );        /* mareas file is read only */
   if (aflch > 0 )
      adbid = fsd_open(aflch);

   if (aflch < 0 || adbid < 0 )         /* exit if cant open mareas_dbs */
   {
     log("Bad mareas file");
     return(-1);
   }
/*------------------------------------
      for each marea, if it's an
     echomail area, export new mail.
     If it's a netmail area, route
     new netmail messages. This allows
     for multiple netmail areas.
  ------------------------------------*/
  (void)fsd_posa(adbid,0);                      /* start at first marea */
  for(f=0; f < fsd_rcnt(adbid); f++)            /* for each marea */
  {
    ans = fsd_get(adbid, 1, 4, &atype);         /* read the area number */
    ans = *((short *)atype);

    if((onearea >= 0) && (ans != onearea))
       goto skiparea; /* skip if we're doing a single area, and this isnt it */

    ans = fsd_get(adbid, 6, 4, &atype);         /* read the area type */
    if (ans > 0)
    {
      atype[ans] = '\0';
      if (netonly)
        if (strchr(atype,'N') == NULL)
          goto skiparea;
      myzone = 0;
      mynet = 0;
      mynode = 0;
      mypoint = 0;
      myfake = 0;
      ans = fsd_get(adbid, 10, 36, &network);    /* get network name */
      if (ans > 0)
      {
        (void)strcpy(&network[ans],"_PNT"); /* build pointnet variable name */
        sysvar(network,pointnet,BMAX);  /* get pointnet nr for this network */
        myfake = (unsigned short)atoi(pointnet); /* and convert to a number */
        network[ans] = '\0';            /* back to network name */
        sysvar(network,temp,BMAX);      /* get network z:n/d.p in temp[] */
        tptr = &temp[0];
        tokptr  = strchr(tptr, ':');
        if(tokptr != NULL)
        {
          *tokptr = '\0';
          myzone = (unsigned short) atoi(tptr);
          tptr = tokptr+1;
        }
        tokptr  = strchr(tptr, '/');
        if(tokptr != NULL)
        {
          *tokptr = '\0';
          mynet = (unsigned short) atoi(tptr);
          tptr = tokptr+1;
        }
        tokptr  = strchr(tptr, '.');
        if(tokptr != NULL)
        {
          *tokptr = '\0';
          mypoint = (unsigned short) atoi(tokptr+1);
        }
        mynode = (unsigned short) atoi(tptr);
      }
      if (strchr(atype,'N') != NULL)            /* check for netmail area */
         netmail(adbid);
      else
      {
        ans = fsd_get(adbid, 7, 400, &feeds);  /* get the feed list */
        if (ans > 0)
        {
           feeds[ans] = '\0';
           echomail(adbid, feeds);
        }
      }
    }
skiparea:
    (void)fsd_posr(adbid,1);                    /* next marea */
  }
/*------------------------------------------------
     move _bdl bundles into arcmail in outbound.
  ------------------------------------------------*/
     (void)strcpy(temp,tempdir);
     (void)strcat(temp,"*_bdl");        /* wildcard all bundles in tempdir */
     dirch = open_qdir(tempdir);
     while(read_qdir(dirch, temp, pktname, &qd, 0))
     {
       name_ptr = pktname;
       name_ptr += strlen(tempdir);     /* point to zzzz_12345678_bdl */
       (void)sprintf(arcname,"%s%s",outbound,name_ptr);
       namelen = strlen(arcname);
       namelen -= 3;                    /* get posn for extension (not _ ) */
       (void)strcpy((char *)&arcname[namelen],day);
       arcname[namelen-1] = '.';

       fp  = fopen(pktname,"r+");       /* open the packet up */
       ans = readword(fp);              /* get pkt header */
       td  = readword(fp);              /* read destination node */
       ans = readword(fp);
       ans = readword(fp);
       ans = readword(fp);
       ans = readword(fp);
       ans = readword(fp);
       ans = readword(fp);
       ans = readword(fp);
       ans = readword(fp);
       ans = readword(fp);
       tn  = readword(fp);            /* destination net */

       (void)fseek(fp, 0, SEEK_END);  /* goto file end */
       (void)fputc(0, fp);            /* send 2 nuls to signify eof */
       (void)fputc(0, fp);
       (void)fclose(fp);
       (void)strcpy(attname,arcname);    /* outbound_zzzz_12345678_SA0 */
       namelen = strlen(outbound);
       namelen += 5;                     /* get position for net nr */
       (void)sprintf(newname,"%04x%04x.flo",tn,td);
       (void)strcpy((char *)&attname[namelen],newname);
                                        /* outbound_zzzz_98765432.flo */

       rnum += 1;                       /* rename the bundle to a time.pkt */
       (void)sprintf(newname,"%s%08X.PKT",outbound,rnum);
       f = rename(pktname,newname);
       if (f != 0)
       {
         (void)printf("Rename failed, %s -> %s\n",pktname,newname);
         f = copyfile(pktname,newname);
         if (f != 0)
           (void)printf("Copy failed too\n");
         else
           (void)remove(pktname);
       }
       newzip = 0;                      /* work out whether to create a new
                                           archive, or add to an old one */
       while(1)
       {
         zipchan = io_open(arcname,1);  /* does the archive already exist? */
         if(zipchan > 0)
         {
           ziptime = -1;                /* read the update date */
           ferr = fs_date(zipchan,-1,0,&ziptime);
           (void)io_close(zipchan);
           if(ferr != 0)
             break;                     /* cant read date - assume it's ok */

           ziptime += (24*60*60);       /* if the archive is less than */
           if(ziptime > mt_rclck())     /* one day old, add to it */
              break;

           ferr = strlen(arcname);
           if(arcname[ferr-1] == '9')   /* if .DD9 then dont try any further */
             break;
           arcname[ferr-1]++;           /* try next filename */
         }
         else
         {
           newzip = 1;                  /* no match, create a new archive */
           break;
         }
       }
       if(newzip)                       /* new archives need adding to _ATT */
       {
         ferr = io_open(attname,0);     /* open the _ATT if it exists */
         if(ferr < 0)
           ferr = io_open(attname,3);   /* otherwise, open a new _ATT */
         (void)fs_pos(ferr, 0, 2);      /* goto _ATT file end */
         (void)io_sbyte(ferr, -1, 94);  /* prefix 'delete me' */
         (void)io_sstrg(ferr, -1, arcname, (short)strlen(arcname));
         (void)io_sbyte(ferr, -1, 10);  /* write out filename and a LF */
         (void)io_close(ferr);
       }
       (void)sprintf(cmdline,scancmd,arcname,newname);
       (void)execl(zipper, (int *)-1L, "Zipper", cmdline, NULL);
     }
     (void)io_close(dirch);

/*------------------------------------
        shut everything down
  ------------------------------------*/
     if(argc != 2)
     {
       (void)io_close(aflch);
       (void)fsd_close(adbid);
       if(total == 1)
       {
         log("Processed 1 message");
       }
       else
       {
         (void)sprintf(logmsg,"Processed %d messages",total);
         log(logmsg);
       }
     }
     ferr = mt_rclck();             /* get finish time      */
     ferr -= unixtoql;              /* in unix base (1961)  */
     now = localtime(&ferr);        /* fill time structure  */
     (void)strftime(logmsg, 39,     /* turn into ascii string */
           "Finished at %H:%M:%S", now);
     log(logmsg);

     FreeSrvThg (CLNT, "pbox");
 }
 else
 {
   (void)puts("ERROR - No Pbox server !");
 }
 return(0);
}
/*---------------------------------------------------------------------------*/
int route(long dbid, FILE *chan) /* write message into file, append 2 nulls */
{
short len;
char ans[82];
long written;
struct tm *t;

      len = fsd_get(dbid, 20, 32000, msgtext);
      msgtext[len] = '\0';

      (void)fputc(2,chan);              /* type 2,0 message */
      (void)fputc(0,chan);
      outword(dbid,17,chan);            /* orignode in intel format */
      outword(dbid,13,chan);            /* destnode */
      outword(dbid,16,chan);            /* orignet */
      outword(dbid,12,chan);            /* destnet */
      (void)fsd_get(dbid,19,2,&len);    /* attrib */
      len &= 0x7413;                    /* mask unwanted bits */
      intel(chan,len);                  /* write out part-attrib */
      (void)fputc(0,chan);              /* zero the 'cost' field */
      (void)fputc(0,chan);
      len = fsd_get(dbid, 6, 4, &ans);  /* read 'written' time */
      written = *((long *)ans);
      written -= unixtoql;              /* in unix base (1961) */
      t = localtime(&written);          /* fill time structure */
      (void)strftime( ans, 39,          /* turn into ascii string */
            "%d %b %y  %H:%M:%S", t);
      (void)fputs(ans,chan);            /* and write it out */
      (void)fputc(0,chan);              /* terminate string */
      len = fsd_get(dbid, 2, 36, &ans); /* read 'touser' */
      ans[len] = '\0';
      (void)fputs(ans,chan);            /* and write it out */
      (void)fputc(0,chan);              /* terminate string */
      len = fsd_get(dbid, 1, 36, &ans); /* read 'fromuser' */
      ans[len] = '\0';
      (void)fputs(ans,chan);            /* and write it out */
      (void)fputc(0,chan);              /* terminate string */
      len = fsd_get(dbid, 3, 72, &ans); /* read 'subject' */
      ans[len] = '\0';
      (void)fputs(ans,chan);            /* and write it out */
      (void)fputc(0,chan);              /* terminate string */
      (void)fputs(msgtext,chan);        /* write out the message text */
      (void)fputc(0,chan);              /* terminate string */
      (void)fputc(0,chan);              /* terminate packet */
      (void)fputc(0,chan);
      return(0);
}
/*---------------------------------------------------------------------------*/
void netmail(long dbid)
{
/*
        Netmail packets are  zzzz_nnnndddd.out in outbound
*/
short  len;                     /* length of reply */
long   mdbid = -1;              /* message area dbid */
long   mflch = -1;              /* and channel ID */
FILE   *rtfl;                   /* route file */
unsigned short  dzone = 0;
unsigned short  dnet = 0;
unsigned short  dnode = 0;
unsigned short  dpoint = 0;
unsigned short  ozone = 0;
unsigned short  onet = 0;
unsigned short  onode = 0;
unsigned short  opoint = 0;
char   ans[402];                /* reply buffer for fsd_xxx functions */
char   filename[42];
char   msgid[82];
char   reqfiles[74];
int    f,c;
FILE   *msgfl;
char   lyne[42];
int    fmzn,tozn,fmnd,fmnt,tond,tont;
char   *ptr;
char   *eol;
unsigned short  attr;
void   *a;
short  rlen;
struct stat st;
char   fname[80];
long   chan;
char   direct;

   len = fsd_get(dbid, 2, 40, &areaname);       /* local area name */
   areaname[len] = '\0';                        /* needed for myaddress */

   len = fsd_get(dbid, 4, 400, &ans);  /* this is the mail database filename */
   if (len > 0)
   {
     ans[len] = '\0';
     mflch = io_open( ans, 0 );         /* mail file is read/write */
     (void)puts(ans);                   /* report mail filename */
     if (mflch > 0 )
        mdbid = fsd_open(mflch);

     if (mflch >= 0 && mdbid >= 0 )     /* if opened file ok */
     {
       if(scancount >= 0)
       {
         f = fsd_rcnt(mdbid);
         if(scancount <= f)
         {
           c = f - scancount;
           (void)fsd_posa(mdbid,c);       /* scan from this message */
           c = scancount;
         }
         else
         {
           (void)fsd_posa(mdbid,0);
           c = f;
         }
       }
       else
       {
         f = fsd_rcnt(mdbid);
         c = 0;
         (void)fsd_posa(mdbid,f);                 /* start at last message */
         while(f > 0)                             /* step back until a 'sent' */
         {                                        /* message is found or eof */
           len = fsd_get(mdbid, 8, 400, &ans);    /* read the 'sent' date */
           if ( *((long *)ans) == 0 )             /* 0 means not processed yet */
           {
             (void)fsd_posr(mdbid,-1);            /* previous record */
             f--;
             c++;
           }
           else
           {
             (void)fsd_posr(mdbid,1);             /* skip last 'sent' one */
             break;
           }
         }
       }
       if(c > 1)
         (void)printf("%d new messages\n",c);
       if(c == 1)
         (void)printf("1 new message\n");
       f = c;
       for(f=f; f >0; f--)                      /* for each message */
       {
         len = fsd_get(mdbid,11, 2, &dzone);    /* read target net/node */
         len = fsd_get(mdbid,12, 2, &dnet);
         len = fsd_get(mdbid,13, 2, &dnode);
         len = fsd_get(mdbid,14, 2, &dpoint);
         if((onearea >= 0) && (onefeed[0] != '\0'))
         {
           (void)sprintf(ans,"%d:%d/%d.%d",dzone,dnet,dnode,dpoint);
           if(strcmp(ans,onefeed) != 0)
              goto ignorit;
         }
         (void)fsd_get(mdbid,19,2,&attr);       /* get attributes word */
/*
         Attributes supported in this version of Pbox are:-
         0      private         just pass flag on
         1      crash           dont route the msg
         2      recd            mark when read by recipient
         3      sent            mark when scanned
         4      fileattached    put name(s) in .flo file
         5      intransit       set if message is routed
         7      killsent        set 'deleted' flag
         9      holdforpickup   put msg in .hut file, not usual .out file
         11     filerequest     put name(s) in .req file
         15     fileupdrequest  put name(s) and date in .req file
*/

         /* see if it's for me. */
         if(myaddress(dzone,dnet,dnode,dpoint) != 0)
         {
           if (attr & 0x8800)                /* check for file request  */
           {                                 /* and file update request */
             /* --------------------------------------------------------------
                Here we need to process the file(s) requested in the "subject"
                field. I have no idea what an 'update' request looks like.
                Simple requests can be done by putting the name(s) into .HLO
                Only allow requests from listable groups, or magic names.
                Requests from non-listable groups need to be done by a caller
                even if the caller is normally allowed access to the group.
                This is because we havent verified the caller is who he says
                he is (no user login password on crash netmail)
                --------------------------------------------------------------
             */
             len = fsd_get(mdbid,15, 2, &dzone);
             len = fsd_get(mdbid,16, 2, &dnet); /* get who to send files to */
             len = fsd_get(mdbid,17, 2, &dnode);
             len = fsd_get(mdbid,18, 2, &dpoint);
             (void)sprintf(logmsg,"File Request from %d:%d/%d.%d"
                                   ,dzone,dnet,dnode,dpoint);
             log(logmsg);

             (void)sprintf(fname,"%s%04X_%04X%04X.hlo",
                           outbound,dzone,dnet,dnode);
             chan = io_open(fname,0);     /* open the .hlo if it exists */
             if(chan < 0)
               chan = io_open(fname,3);     /* otherwise, open a new .hlo */
             (void)fs_pos(chan, 0, 2);      /* goto .hlo file end */
             len = fsd_get(mdbid,3,72,&reqfiles); /* get file name(s) */
             if (len > 0)                   /* there are some names */
             {
                reqfiles[len]='\0';
                reqfiles[len+1]='\0';   /* second terminator for eol test */

                   ptr = &reqfiles[0];
                   while (1)
                   {
                     while ((*ptr == ' ') || (*ptr == ',')) ptr++;
                     if (*ptr == '\0') break;      /* no more names */
                     eol = ptr;                    /* ptr -> start of name */
                     while ((*eol != '\0') && (*eol != ' ') && (*eol != '\0'))
                         eol++;
                     *eol = '\0';                  /* eol -> end of name */
                     (void)strcpy(logmsg,"reqfile x "); /* x = listable only */
                     (void)strcat(logmsg,ptr);
                     a=Request ("pbox", logmsg, -1, &rlen);
                     if (a == NULL)
                     {
                         (void)strcpy(logmsg,"Cant find \"");
                         (void)strcat(logmsg,ptr);
                         (void)strcat(logmsg,"\"");
                     }
                     else
                     {
                       if (stat(a,&st) == 0)
                       {
                         (void)strcpy(logmsg,"Sending \"");
                         (void)strcat(logmsg,a);
                         (void)strcat(logmsg,"\"");
                         (void)io_sstrg(chan, -1, a, (short)strlen(a));
                         (void)io_sbyte(chan, -1, 10);  /* add a LF */
                       }
                       else
                       {
                         (void)strcpy(logmsg,"Cant find \"");
                         (void)strcat(logmsg,ptr);
                         (void)strcat(logmsg,"\",\"");
                         (void)strcat(logmsg,a);
                         (void)strcat(logmsg,"\"");
                       }
                       free(a);
                     }
                     log(logmsg);
                     ptr = eol;
                     ptr++;
                   }
             }
             (void)io_close(chan);
             len = fsd_get(mdbid,11, 2, &dzone);
             len = fsd_get(mdbid,12, 2, &dnet); /* get message target back */
             len = fsd_get(mdbid,13, 2, &dnode);
             len = fsd_get(mdbid,14, 2, &dpoint);
           }
           (void)fsd_put(mdbid,8,4,&rnum);   /* stamp 'sent' date */
           attr |= 8;                        /* flag 'sent by me' */
           (void)fsd_put(mdbid,19,2,&attr);  /* write new attributes */
           if (attr & 0x0080)                /* check "killsent" */
              (void)fsd_put(mdbid,21,2,&attr);
           (void)fsd_updt(mdbid);            /* and update the record */
         }
         else   /* message is not for me */
         {
           len = fsd_get(mdbid,15, 2, &ozone);  /* get senders number */
           len = fsd_get(mdbid,16, 2, &onet);
           len = fsd_get(mdbid,17, 2, &onode);
           len = fsd_get(mdbid,18, 2, &opoint);
           len = fsd_get(mdbid,4,80,&msgid);
           if(len < 0)  len = 0;
           msgid[len] = '\0';

           (void)sprintf(logmsg,"Netmail (%s) for %d:%d/%d.%d,\nAttributes %04X",
                 msgid,dzone,dnet,dnode,dpoint,attr);
           log(logmsg);

           /* see if it's for one of my points, if so, use pointnet */
           if(myaddress(dzone,dnet,dnode,0) && (dpoint != 0))
           {
              dnet   = myfake;
              dnode  = dpoint;
              dpoint = 0;
           }
           if (attr & 0x8800)                /* check for file request */
           {
             (void)sprintf(fname,"%s%04X_%04X%04X.req",
                           outbound,dzone,dnet,dnode);
             chan = io_open(fname,0);     /* open the .REQ if it exists */
             if(chan < 0)
               chan = io_open(fname,3);   /* otherwise, open a new .REQ */
             (void)fs_pos(chan, 0, 2);    /* goto file end */
             len = fsd_get(mdbid,3,72,&reqfiles); /* get file name(s) */
             if (len > 0)                   /* there are some names */
             {
                reqfiles[len]='\0';
                reqfiles[len+1]='\0';   /* second terminator for eol test */
                (void)sprintf(logmsg,"Requesting: (%s)",reqfiles);
                log(logmsg);

                ptr = &reqfiles[0];
                while (1)
                {
                   while ((*ptr == ' ') || (*ptr == ',')) ptr++;
                   if (*ptr == '\0') break;      /* no more names */
                   eol = ptr;                    /* ptr -> start of name */
                   while ((*eol != '\0') && (*eol != ' ') && (*eol != '\0'))
                       eol++;
                   *eol = '\0';                  /* eol -> end of name */
                   (void)io_sstrg(chan, -1, ptr, (short)strlen(ptr));
                   (void)io_sbyte(chan, -1, 10);  /* add a LF */
                   ptr = eol;
                   ptr++;
                }
             }                          /* end of "if there are names" */
             (void)io_close(chan);
           }
           if (attr & 0x0010)                /* check for file attached */
           {
             /*  If the message was entered on this bbs, look filenames up
                 via the server. If the message came from outside, the
                 files should be in inbound. This is how points pass files
                 between each other. Either way, attached files go into
                 the target's .flo file.
             */
             (void)sprintf(fname,"%s%04X_%04X%04X.flo",
                           outbound,dzone,dnet,dnode);
             chan = io_open(fname,0);     /* open the _ATT if it exists */
             if(chan < 0)
               chan = io_open(fname,2);   /* otherwise, open a new _ATT */
             (void)fs_pos(chan, 0, 2);    /* goto _ATT file end */
             len = fsd_get(mdbid,3,72,&reqfiles); /* get file name(s) */
             if (len > 0)                   /* there are some names */
             {
                reqfiles[len]='\0';
                reqfiles[len+1]='\0';   /* second terminator for eol test */
                (void)sprintf(logmsg,"Attaching \"%s\"",reqfiles);
                log(logmsg);

                if (myaddress(ozone,onet,onode,opoint) == 0)
                {  /* not entered here, so files should be in inbound */
                   ptr = &reqfiles[0];
                   while (1)
                   {
                     while ((*ptr == ' ') || (*ptr == ',')) ptr++;
                     if (*ptr == '\0') break;      /* no more names */
                     eol = ptr;                    /* ptr -> start of name */
                     while ((*eol != '\0') && (*eol != ' ') && (*eol != '\0'))
                         eol++;
                     *eol = '\0';                  /* eol -> end of name */
                     (void)strcpy(logmsg,inbound);
                     (void)strcat(logmsg,ptr);
                     if (stat(logmsg,&st) == 0)
                     {
                       (void)io_sstrg(chan, -1, logmsg, (short)strlen(logmsg));
                       (void)io_sbyte(chan, -1, 10);  /* add a LF */
                       (void)strcpy(logmsg,"Sending \"");
                       (void)strcat(logmsg,ptr);
                       (void)strcat(logmsg,"\"");
                     }
                     else
                     {
                       (void)strcpy(logmsg,"Cant find \"");
                       (void)strcat(logmsg,ptr);
                       (void)strcat(logmsg,"\" in inbound");
                     }
                     log(logmsg);

                     ptr = eol;
                     ptr++;
                   }
                }
                else       /* msg entered here, try names directly first,
                              and if not found, lookup filenames via server */
                {
                   ptr = &reqfiles[0];
                   while (1)
                   {
                     while ((*ptr == ' ') || (*ptr == ',')) ptr++;
                     if (*ptr == '\0') break;      /* no more names */
                     eol = ptr;                    /* ptr -> start of name */
                     while ((*eol != '\0') && (*eol != ' ') && (*eol != '\0'))
                         eol++;
                     *eol = '\0';                  /* eol -> end of name */
                     if (stat(ptr,&st) == 0)
                     {
                       (void)strcpy(logmsg,"Sending \"");
                       (void)strcat(logmsg,ptr);
                       (void)strcat(logmsg,"\"");
                       (void)io_sstrg(chan, -1, ptr, (short)strlen(ptr));
                       (void)io_sbyte(chan, -1, 10);  /* add a LF */
                     }
                     else   /* this is a file attach from this bbs */
                     {
                       (void)strcpy(logmsg,"reqfile x "); /* listable or magic */
                       (void)strcat(logmsg,ptr);
                       a=Request ("pbox", logmsg, -1, &rlen);
                       if (a == NULL)
                       {
                           (void)strcpy(logmsg,"Cant find \"");
                           (void)strcat(logmsg,ptr);
                           (void)strcat(logmsg,"\"");
                       }
                       else
                       {
                         if (stat(a,&st) == 0)
                         {
                           (void)strcpy(logmsg,"Sending \"");
                           (void)strcat(logmsg,a);
                           (void)strcat(logmsg,"\"");
                           (void)io_sstrg(chan, -1, a, (short)strlen(a));
                           (void)io_sbyte(chan, -1, 10);  /* add a LF */
                         }
                         else
                         {
                           (void)strcpy(logmsg,"Cant find \"");
                           (void)strcat(logmsg,ptr);
                           (void)strcat(logmsg,"\" \"");
                           (void)strcat(logmsg,a);
                           (void)strcat(logmsg,"\"");
                         }
                         free(a);
                       }
                     }
                     log(logmsg);
                     ptr = eol;
                     ptr++;
                   }
                }
             }                          /* end of "if there are names" */
             (void)io_close(chan);
           }                            /* end of "files attached" */

  /*--------------------------------------------
        Work out who to route the msg through
    --------------------------------------------*/
           direct = 1;                /* assume sending direct to address */
           if ((attr & 0x8A12) == 0)  /* dont route msgs with files attached */
           {                          /* or requested, or update request, or */
                                      /* if marked "crash" or "hold" */
             rtfl = fopen(routing, "r");       /* route file is read only */
             if(rtfl != NULL)
             {
               while(1)
               {
                 fmzn = tozn = fmnd = fmnt = tond = tont = 0;
                 if(fgets(lyne, 40, rtfl) == NULL)     /* check each line   */
                   break;                              /* no routing if eof */
                 ptr = lyne;
                 eol = ptr;
                 while (*eol != ':') eol++;
                 eol++;
                 fmzn = atoi(ptr);
                 ptr = eol;
                 while (*eol != '/') eol++;
                 eol++;
                 fmnt = atoi(ptr);
                 ptr = eol;
                 while(*eol != ' ') eol++;
                 while(*eol == ' ') eol++;
                 fmnd = atoi(ptr);
                 ptr = eol;
                 while (*eol != ':') eol++;
                 tozn = atoi(ptr);
                 eol++;
                 ptr = eol;
                 while (*eol != '/') eol++;
                 tont = atoi(ptr);
                 eol++;
                 ptr = eol;
                 tond = atoi(ptr);

                 if(fmzn == 0) fmzn = dzone;
                 if(fmnt == 0) fmnt = dnet;    /* check wildcards */
                 if(fmnd == 0) fmnd = dnode;

                 if((fmzn == dzone) && (fmnt == dnet) &&
                    (fmnd == dnode))   /* MATCH */
                 {
                   dzone = (unsigned short)tozn;
                   dnet  = (unsigned short)tont;
                   dnode = (unsigned short)tond;
                   if((fmzn == dzone) && (fmnt == dnet) &&
                      (fmnd == dnode) && (dpoint == 0))
                     direct = 1;        /* direct match */
                   else
                     direct = 0;        /* routed */
                   break;
                 }
               }                          /* end while */
               (void)fclose(rtfl);
             }                            /* route file opened */
           }                              /* file attached */
           if (direct)
             (void)sprintf(logmsg,"Sending message to %d:%d/%d",dzone,dnet,dnode);
           else
           {
             (void)sprintf(logmsg,"Routing message to %d:%d/%d",dzone,dnet,dnode);
             attr |= 0x0020;    /* mark as in transit *
             (void)fsd_put(mdbid,19,2,&attr);  /* write new attributes */
             (void)fsd_updt(mdbid);            /* and update the record */
           }
           log(logmsg);

           if (attr & 0x0200)   /* hold for pickup? */
                (void)sprintf(filename,"%s%04X_%04X%04X.hut",
                              outbound, dzone, dnet, dnode);
           else                 /* no, can send it */
                (void)sprintf(filename,"%s%04X_%04X%04X.out",
                              outbound, dzone, dnet, dnode);

           msgfl = fopen(filename, "r+");   /* file to write message to */
           if(msgfl != NULL)                   /* if it exists, */
             (void)fseek(msgfl, -2L, SEEK_END); /* position near file end */
           else                                 /* to strip surplus NULLs */
           {
             msgfl = fopen(filename, "w+"); /* must be a new file */
             intel(msgfl,mynode);           /* entries in intel format */
             intel(msgfl,dnode);
             intel(msgfl,1900+(now->tm_year));
             intel(msgfl,now->tm_mon);
             intel(msgfl,now->tm_mday);
             intel(msgfl,now->tm_hour);
             intel(msgfl,now->tm_min);
             intel(msgfl,now->tm_sec);
             intel(msgfl,0);             /* baud is zeroed */
             intel(msgfl,2);             /* packet type 2+ */
             if(mypoint != 0)            /* use auxnet for points */
               intel(msgfl,0xffff);
             else
               intel(msgfl,mynet);
             intel(msgfl,dnet);
             intel(msgfl,0x01ff);        /* product code/version */
             for(c=1; c<5; c++)
               intel(msgfl,0);           /* password */
             intel(msgfl,myzone);        /* orig zone for Qmail */
             intel(msgfl,dzone);         /* dest zone for Qmail */
             if(mypoint != 0)            /* use auxnet for points */
               intel(msgfl,mynet);
             else
               intel(msgfl,0);           /* no auxnet for nodes */
             (void)fputc(((capable & 0xff00) >> 8),msgfl);
             (void)fputc((capable & 0x00ff),msgfl);
             intel(msgfl,0x0100);       /* revision level */
             intel(msgfl,capable);      /* capability level */
             intel(msgfl,myzone);       /* for FrontDoor etc. */
             intel(msgfl,dzone);        /* for FrontDoor etc. */
             intel(msgfl,mypoint);      /* for FrontDoor etc. */
             intel(msgfl,dpoint);       /* for FrontDoor etc. */
             intel(msgfl,0);            /* filler */
             intel(msgfl,0);            /* filler */

           }                             /* end of new file header */
           if(route(mdbid,msgfl) == 0)      /* route msg to file */
           {
              total++;
              (void)fsd_put(mdbid,8,4,&rnum);   /* stamp 'sent' date */
              (void)fsd_updt(mdbid);            /* and update record */
           }
           else
           {
            (void)sprintf(logmsg,"Failed to route %d",fsd_rcnt(mdbid));
            log(logmsg);
           }
           (void)fclose(msgfl);
         }                                      /* end of 'not to us' */
ignorit:
         (void)fsd_posr(mdbid,1);               /* next message */
       }
       (void)io_close(mflch);           /* close the database */
       (void)fsd_close(mdbid);
     }
   }
}
/*---------------------------------------------------------------------------*/
int myaddress(unsigned short z, unsigned short n,
              unsigned short d, unsigned short p)
{
char *tokptr, *tptr;
char temp[84];
unsigned short mz,mn,md,mp;
long fid;
int ferr;

        if ((myzone  == z) && (mynet == n) && (mynode == d) && (mypoint == p))
        {                       /* try main number first */
            (void)sprintf(logmsg,"Matches my address %d:%d/%d.%d",z,n,d,p);
            log(logmsg);
            return(1);
        }
        if (strchr(atype,'A') != NULL)          /* is it multi-address */
        {
          (void)strcpy(temp,sysdir);            /* build filename */
          (void)strcat(temp,"info_");
          (void)strcat(temp,areaname);
          (void)strcat(temp,"_addr");

          fid = io_open(temp,1);                /* open read-only */
          if (fid < 0) return(0);               /* no match if no file */

          while(1)
          {
            ferr = io_fline(fid, -1, &temp[0], 82);
            if (ferr < 0)
            {
              (void)io_close(fid);              /* error, no match */
              return(0);
            }
            if (ferr > 2)
            {
              temp[ferr] = '\0';
              tptr = &temp[2];                  /* skip number,space */
              tokptr  = strchr(tptr, ':');
              if(tokptr != NULL)
              {
                *tokptr = '\0';
                mz = (unsigned short) atoi(tptr);
                tptr = tokptr+1;
              }
              tokptr  = strchr(tptr, '/');
              if(tokptr != NULL)
              {
                *tokptr = '\0';
                mn = (unsigned short) atoi(tptr);
                tptr = tokptr+1;
              }
              tokptr  = strchr(tptr, '.');
              if(tokptr != NULL)
              {
                *tokptr = '\0';
                mp = (unsigned short) atoi(tokptr+1);
              }
              md = (unsigned short) atoi(tptr);

              /* does this line match? */
              if ((mz == z) && (mn == n) && (md == d) && (mp == p))
              {
                (void)io_close(fid);
                (void)sprintf(logmsg,"Matches my address %d:%d/%d.%d",
                              z,n,d,p);
                log(logmsg);
                return(1);
              }
            }   /* line long enough */
          }     /* end while */
        }
        return(0);      /* not multi-address */
}
/*---------------------------------------------------------------------------*/
int add_feeds(char *feeds,unsigned short o_node)
/*                  Add feeds to the SEEN-BY lines
                    Put all addresses who havent seen msg in the feeds list.
                    Return how many feeds havent seen the msg
*/
{
char *eot,*ptr;
unsigned short cnet,cnode;
int listed;
int count = 0;

  cnet = 0;
  cnode = 0;

  eot = feeds;
  if (rescan)
     eot = onefeed;

  while(1)
  {
    while(*eot == ' ') eot++;
    if (isdigit(*eot) == 0)     /* allow for spaces on line end */
      break;
    ptr = eot;                  /* ptr -> start of a number */
    while(isdigit(*eot)) eot++; /* eot -> char after end of number */
    if(*eot == '/')
    {
       cnet = (unsigned short)atoi(ptr);
       eot++;                   /* skip past '/' */
    }
    else
    {
      if(*eot == ':')           /* ignore any zone numbers found */
        eot++;
      else
      {
        cnode = (unsigned short)atoi(ptr);
        if (cnet != myfake)       /* dont add points to seen-by lines */
        {
          listed = insert(&seen_ptr,cnet,cnode);
                                  /* 0 = fail, 1 = ok, -1 = duplicate */
          if (listed == 0)
             break;               /* dont continue if out of memory */
        }
        else
          listed = 1;             /* points arent in seen-by lines */
        if((listed != -1) || (rescan == 1))
                                  /* dont feed if its already in seenby list
                                     unless it's a rescan */
        {
          if(cnet != myfake)      /* always feed to real nodes */
          {
            (void)append(&feed_ptr, cnet, cnode);
             count++;
          }
          else                    /* feed to all fakes EXCEPT originator */
          {
            if(cnode != o_node)
            {
              (void)append(&feed_ptr, cnet, cnode);
               count++;
            }
          }
        }
      }
    }
    if(*eot == '\0' || *eot == '\r')
      break;
  }
  return(count);
}
/*---------------------------------------------------------------------------*/
void add_to_packets(FILE *msg, char *area, char *msgid)
                        /* send message to feeds in feed_ptr list. */
{
struct list *curr_ptr;
char filename[BMAX+2];
FILE *feedfile;
int c;

  curr_ptr = feed_ptr;
  while(1)
  {
    if(curr_ptr == NULL)
      break;

    if(mypoint == 0)
        (void)sprintf(filename,"%s%04X_%04X%04X_bdl",tempdir, myzone,
                      (unsigned short)(mynet-(curr_ptr->net)),
                      (unsigned short)(mynode-(curr_ptr->node)) );
    else
        (void)sprintf(filename,"%s%04X_%04X%04X_bdl",tempdir, myzone,
                      (unsigned short)(myfake-(curr_ptr->net)),
                      (unsigned short)(mypoint-(curr_ptr->node)) );

    (void)sprintf(logmsg,"%s (%s) to %d/%d", area, msgid,
                             curr_ptr->net,curr_ptr->node);
    log(logmsg);

    feedfile = fopen(filename,"r+");
    if(feedfile != NULL)                     /* if it exists, */
      (void)fseek(feedfile, 0L, SEEK_END);   /* position at file end */
    else
    {                                    /* if not, new file   */
      feedfile = fopen(filename,"w+");   /* so create a header */
      intel(feedfile,mynode);            /* entries in intel format */
      intel(feedfile,curr_ptr->node);
      intel(feedfile,1900+(now->tm_year));
      intel(feedfile,now->tm_mon);
      intel(feedfile,now->tm_mday);
      intel(feedfile,now->tm_hour);
      intel(feedfile,now->tm_min);
      intel(feedfile,now->tm_sec);
      intel(feedfile,0);             /* baud is zeroed */
      intel(feedfile,2);             /* packet type 2  */
      if(mypoint != 0)               /* use auxnet for points */
        intel(feedfile,0xffff);
      else
        intel(feedfile,mynet);
      intel(feedfile,curr_ptr->net);
      intel(feedfile,0x01ff);        /* product code/version */
      for(c=1; c<5; c++)
        intel(feedfile,0);           /* password */
      intel(feedfile,myzone);        /* orig zone for Qmail */
      intel(feedfile,myzone);        /* echomail doesnt cross zones */
      if(mypoint != 0)               /* use auxnet for points */
        intel(feedfile,mynet);
      else
        intel(feedfile,0);          /* no auxnet for nodes */
      (void)fputc(((capable & 0xff00) >> 8),feedfile);
      (void)fputc((capable & 0x00ff),feedfile);
      intel(feedfile,0x0100);       /* revision level */
      intel(feedfile,capable);      /* capability level */
      intel(feedfile,myzone);       /* for FrontDoor etc. */
      intel(feedfile,myzone);       /* dont cross zones */
      intel(feedfile,mypoint);      /* for FrontDoor etc. */
      intel(feedfile,0);            /* no points in seenby's */
      intel(feedfile,0);            /* filler */
      intel(feedfile,0);            /* filler */
    }

    (void)fseek(msg, 2L, SEEK_SET);  /* position over orignode */
    intel(msg,mynode);
    (void)fseek(msg, 6L, SEEK_SET);  /* now over orignet */
    intel(msg,mynet);
    (void)fseek(msg, 4L, SEEK_SET);  /* position over destnode */
    intel(msg,curr_ptr->node);
    (void)fseek(msg, 8L, SEEK_SET);  /* now over destnet */
    intel(msg,curr_ptr->net);
    (void)fseek(msg, 0L, SEEK_SET);  /* position at start of msg */
    while(1)
    {
      c = fgetc(msg);
      if (c == EOF)
        break;
      (void)fputc(c,feedfile);
    }
    (void)fclose(feedfile);
    curr_ptr = curr_ptr->next_ptr;     /* next link */
  }

}
/*---------------------------------------------------------------------------*/
void intel(FILE *chan, int value)
{
  unsigned char *ptr;
  unsigned short word;
  unsigned char low,high;

  word = (unsigned short)value;
  ptr  = (unsigned char *)&word;
  high = *ptr;
  ptr++;
  low  = *ptr;

  (void)fputc(low,  chan);
  (void)fputc(high, chan);
}
/*---------------------------------------------------------------------------*/
void echomail(long dbid, char *feeds)
{
/*
        Echomail packets are TTTTTTTT.PKT stored in a zip file named
        ZZZZ_NNNNnnnn.DD0 in outbound.
        The full device_dir_filename of the zip file is written into an
        _ATT file called ZZZZ_NNNNnnnn.flo in outbound.
        dest-orig used for the zip file names.
*/
char    ans[42];                /* reply buffer for fsd_xxx functions */
short   len;                    /* length of reply */
long    mdbid = -1;             /* message area dbid */
long    mflch = -1;             /* and channel ID */
int     f;                      /* 'for' loop counter */
int     tosend;                 /* counter */


   len = fsd_get(dbid, 3, 40, &areaname); /* echo name */
   areaname[len] = '\0';

   len = fsd_get(dbid, 4, 40, &ans);    /* read the marea filename */
   if (len > 0)
   {
     ans[len] = '\0';
     mflch = io_open( ans, 0 );         /* mail file is read/write */
     (void)puts(ans);                   /* report mail filename */
     if (mflch > 0 )
        mdbid = fsd_open(mflch);

     if (mflch >= 0 && mdbid >= 0 )             /* if opened file ok */
     {
       if(scancount >= 0)
       {
         f = fsd_rcnt(mdbid);
         if(scancount <= f)
         {
           tosend = f - scancount;
           (void)fsd_posa(mdbid,tosend);       /* scan from this message */
           tosend = scancount;
         }
         else
         {
           (void)fsd_posa(mdbid,0);
           tosend = f;
         }
       }
       else
       {
         tosend = 0;
         f = fsd_rcnt(mdbid);
         (void)fsd_posa(mdbid,f);                 /* start at last message */
         while(f > 0)                             /* step back until a 'sent' */
         {                                        /* message is found or eof */
           len = fsd_get(mdbid, 8, 40, &ans);     /* read the 'sent' date */
           if ( *((long *)ans) == 0 )             /* 0 means not processed yet */
           {
             tosend++;
             (void)fsd_posr(mdbid,-1);            /* previous record */
             f--;
           }
           else
           {
             f++;                                 /* skip last 'sent' one */
             (void)fsd_posr(mdbid,1);
             break;
           }
         }
       }
       if(tosend > 1)
         (void)printf("%d new messages\n",tosend);
       if(tosend == 1)
         (void)printf("%d new message\n",tosend);

       for(; tosend >0; tosend--)               /* for each message */
       {
          if(export(mdbid,feeds) == 0)     /* export msg to feeds */
          {
             total++;
             (void)fsd_put(mdbid,8,4,&rnum);   /* stamp 'sent' date */
             (void)fsd_updt(mdbid);            /* and update record */
          }
          else
          {
            (void)printf("Failed to export %d",fsd_rcnt(mdbid));
          }
          (void)fsd_posr(mdbid,1);          /* next message */
       }
       (void)io_close(mflch);           /* close the database */
       (void)fsd_close(mdbid);
     }
   }
}
/*--------------------------------------------------------------------------*/
void outword(long dbid, short field, FILE *chan)
{
char ans[4];

   if (fsd_get(dbid, field, 2, &ans) >= 0)
   {
     (void)fputc(*((unsigned char *)ans+1),chan);
     (void)fputc(*((unsigned char *)ans),chan);
   }
}
/*--------------------------------------------------------------------------*/
int append( struct list **list, unsigned short net, unsigned short node)
{
  /*
      Add a net/node to the end of a linked list
      Used for PATH lines which are in processed order
  */
  struct list *end_ptr;
  struct list *new_ptr;


  if(*list == NULL)          /* it's a new list */
  {
    new_ptr = (struct list *)malloc(sizeof(struct list));
    if(new_ptr == NULL)
      return(0);
    new_ptr->net = net;
    new_ptr->node = node;
    new_ptr->next_ptr = NULL;
    *list = new_ptr;
    return(1);
  }

  end_ptr = *list;
  while(end_ptr->next_ptr != NULL)
    end_ptr = end_ptr->next_ptr;

  if((end_ptr->net == net) && (end_ptr->node == node))  /* check for dupe */
    return(0);
  new_ptr = (struct list *)malloc(sizeof(struct list));
  if (new_ptr == NULL)
    return(0);
  new_ptr->net = net;
  new_ptr->node = node;
  new_ptr->next_ptr = NULL;
  end_ptr->next_ptr = new_ptr;
  return(1);
}
/*--------------------------------------------------------------------------*/
int insert( struct list **list, unsigned short net, unsigned short node)
{
  /*
       Insert an element into a linked list in net/node order
       suppressing duplicates. Used for SEENBY lines
  */
  struct list *before_ptr; /* insert before this element */
  struct list *after_ptr;  /* and after this one */
  struct list *new_ptr;    /* new data element */

  before_ptr = *list;

  if (before_ptr == NULL)    /* First, check for an empty list */
  {
    new_ptr = (struct list *)malloc(sizeof(struct list));
    if(new_ptr == NULL)
      return(0);
    new_ptr->net = net;
    new_ptr->node = node;
    new_ptr->next_ptr = NULL;
    *list = new_ptr;
    return(1);
  }

  /* ok, not a new list. Are we the same as the 1st element? */
  if ((net == before_ptr->net) && (node == before_ptr->node))
     return(-1);        /* dupe */

  /* should we go before this in the list? */
  if ((net < before_ptr->net) || ((net == before_ptr->net) &&
                                (node < before_ptr->node)))
  {
    new_ptr = (struct list *)malloc(sizeof(struct list));
    if(new_ptr == NULL)
      return(0);        /* failed */
    new_ptr->net = net;
    new_ptr->node = node;
    new_ptr->next_ptr = before_ptr;
    *list = new_ptr;
    return(1);          /* done */
  }

  /* ok, we must be later in the list somewhere */
  after_ptr = before_ptr;
  while(1)
  {
    before_ptr = after_ptr;
    after_ptr = after_ptr->next_ptr;
    
    if (after_ptr == NULL)     /* check for end of list */
        break;

    if (net < after_ptr->net)  /* check if in right place */
      break;
    if ((net == after_ptr->net) && (node <= after_ptr->node))
      break;
  }

  /* we're now positioned where the new entry should go */
  /* check for duplicate net/node entry */
  if ((net == after_ptr->net) && (node == after_ptr->node))
      return(-1);               /* dupe */

  /* ok, it's not a duplicate, so insert it as a new element */
  new_ptr = (struct list *)malloc(sizeof(struct list));
  if(new_ptr == NULL)
    return(0);                  /* failed */
  new_ptr->net = net;
  new_ptr->node = node;
  before_ptr->next_ptr = new_ptr;
  new_ptr->next_ptr = after_ptr;
  return(1);                    /* done */
}
/*--------------------------------------------------------------------------*/
void free_list (struct list *list)
{
   struct list *next;

 if (list != NULL)          /* check there is a list to remove */
 {
   next = list->next_ptr;   /* first item in list is next */
   list->next_ptr = NULL;   /* and list is no more */

   while (next)
   {
      list = next;           /* does not assume "correct" operation of free: */
      next = list->next_ptr; /* i.e. that freed memory is still valid!!!! */
      free (list);
   }
 }
}
/*--------------------------------------------------------------------------*/
char * addline(struct list **list, char *ptr, int type)
/*
        Add all entries in the seen-by line or path-line to the relevant
        linked list
*/
{
char *eot;
short cnet,cnode;
int listed;

  cnet = 0;
  cnode = 0;

  while(1)
  {
    eot = ptr;
    while(*eot == ' ')
      eot++;
    if (isdigit(*eot) == 0)     /* allow for spaces on line end */
      break;
    ptr = eot;
    while(isdigit(*eot))
      eot++;
    if(*eot == '/')
    {
      cnet = (short)atoi(ptr);
      ptr = eot;
      ptr++;
    }
    else
    {
      cnode = (short)atoi(ptr);
      if (type == 1)
      {
         listed = insert(list,cnet,cnode);
         /* 0 = fail, 1 = ok, -1 = duplicate */
      }
      else
      {
         listed = append(list,cnet,cnode);
         /* 0 = fail, 1 = ok, -1 = duplicate */
      }
      if (listed == 0)
        return(NULL);           /* dont continue if out of memory */

      if(*eot == '\0' || *eot == '\r')
        break;
      ptr = eot;
      ptr++;
    }
  }
  if (type == 1)
    return(strstr(ptr, "SEEN-BY: "));
  else
    return(strstr(ptr, "\x01PATH: "));
}
/*--------------------------------------------------------------------------*/
int export(long dbid, char *feeds)
                        /* export msg to feeds. Return 0 if exported ok */
{
short len;
char ans[82];
char tempbuff[82];
long written;
struct tm *t;
char *eotext;    /* pointer to end of text/start of 'seen-by' lines */
char *ptr;
struct list *seen;
unsigned short cnet,onode;
char seenbuff[202];
int retval = -1;        /* assume error */
char msgid[82];
char filename[42];
FILE *chan;

      len = fsd_get(dbid, 20, 32000, msgtext);
      msgtext[len] = '\0';

      seen_ptr = NULL;                  /* zero the linked list pointers */
      path_ptr = NULL;
      feed_ptr = NULL;
      ptr = strstr(msgtext, "SEEN-BY: ");
      if (ptr == NULL)                  /* if there are no seenby's */
      {
        eotext = msgtext;               /* create end pointer */
        eotext += strlen(msgtext);
      }
      else
        eotext = ptr;

   /* build a linked list of all entries in seen-by lines in net/node order */

      while (ptr != NULL)
      {
        ptr += 9;                    /* skip 'SEEN-BY: ' */
        ptr = addline(&seen_ptr,ptr, 1);
      }
   /* build a linked list of paths in arrival order */
      ptr = strstr(eotext, "\x01PATH: "); /* get start of path line */

      while (ptr != NULL)                 /* if there is one */
      {
        ptr += 7;                     /* skip '^aPATH: ' */
        ptr = addline(&path_ptr,ptr, 0);
      }
      len = fsd_get(dbid, 17, 2, &onode); /* read sender node number */
                                          /* which is fakenet point nr */
      if (add_feeds(feeds,onode)  == 0)   /* add in feeds who havent seen it */
      {                                   /* if there are none, don't export */
        retval = 0;
      }
      else                                /* someone hasnt got a copy */
      {
        len = fsd_get(dbid,4,80,msgid);
        msgid[len] = '\0';

        (void)sprintf(filename,"%s%08X_MSG",outbound,rnum);
        rnum++;
        chan = fopen(filename, "w+");     /* file to write message to */

        (void)fputc(2,chan);              /* type 2,0 message */
        (void)fputc(0,chan);
        outword(dbid,17,chan);            /* orignode in intel format */
        outword(dbid,13,chan);            /* destnode */
        outword(dbid,16,chan);            /* orignet */
        outword(dbid,12,chan);            /* destnet */
        outword(dbid,19,chan);            /* attrib */
        (void)fputc(0,chan);              /* zero the 'cost' field */
        (void)fputc(0,chan);
        len = fsd_get(dbid, 6, 4, &ans);  /* read 'written' time */
        written = *((long *)ans);
        written -= unixtoql;              /* in unix base (1961) */
        t = localtime(&written);          /* fill time structure */
        (void)strftime( ans, 39,          /* turn into ascii string */
              "%d %b %y  %H:%M:%S", t);
        (void)fputs(ans,chan);            /* and write it out */
        (void)fputc(0,chan);              /* terminate string */
        len = fsd_get(dbid, 2, 36, &ans); /* read 'touser' */
        ans[len] = '\0';
        (void)fputs(ans,chan);            /* and write it out */
        (void)fputc(0,chan);              /* terminate string */
        len = fsd_get(dbid, 1, 36, &ans); /* read 'fromuser' */
        ans[len] = '\0';
        (void)fputs(ans,chan);            /* and write it out */
        (void)fputc(0,chan);              /* terminate string */
        len = fsd_get(dbid, 3, 72, &ans); /* read 'subject' */
        ans[len] = '\0';
        (void)fputs(ans,chan);            /* and write it out */
        (void)fputc(0,chan);              /* terminate string */

        (void)strcpy(seenbuff,"AREA:");
        (void)strcat(seenbuff,areaname);
        (void)fputs(seenbuff,chan);
        (void)fputc(13,chan);
        *eotext = '\0';                 /* terminate msg at end of text */
        (void)fputs(msgtext,chan);      /* write up to start of SEEN_BYs */
        if(mypoint == 0)
        {
          (void)append(&path_ptr,mynet,mynode);   /* add ourselves to path list */
          (void)insert(&seen_ptr,mynet,mynode);   /* and seen-by list */
        }
        else
        {
          (void)append(&path_ptr,myfake,mypoint);
          (void)insert(&seen_ptr,myfake,mypoint);
        }
        seen = seen_ptr;
        seenbuff[0] = '\0';

        while(1)
        {
          if(seen == NULL)
          {
            if (seenbuff[0] != '\0')
            {
              (void)strcat(seenbuff,"\r");        /* terminate and */
              (void)fputs(seenbuff,chan);         /* write out last line */
            }
            break;                                /* end of linked list */
          }
          if (seenbuff[0] == '\0')                /* start a new line */
          {
            (void)strcpy(seenbuff,"SEEN-BY:");
            cnet = 0;
          }
          if (cnet == seen->net)                  /* if same net, add node */
             (void)sprintf(tempbuff," %d",seen->node);
          else
          {                                  /* if not, add net/node */
            (void)sprintf(tempbuff," %d/%d",seen->net,seen->node);
            cnet = seen->net;
          }

          if ((strlen(seenbuff) + strlen(tempbuff)) > 78)
          {
            (void)strcat(seenbuff,"\r");        /* terminate and output line */
            (void)fputs(seenbuff,chan);         /* if near right margin */
            seenbuff[0] = '\0';                 /* it's an empty line now */
            cnet = 0;
          }
          else
          {
            (void)strcat(seenbuff,tempbuff);   /* there is room to add another */
            cnet = seen->net;                  /* change to new net */
          }
          seen = seen->next_ptr;               /* next entry */
        }

        seen = path_ptr;
        seenbuff[0] = '\0';

        while(1)
        {
          if(seen == NULL)
          {
            if (seenbuff[0] != '\0')
            {
              (void)strcat(seenbuff,"\r\n");      /* terminate and */
              (void)fputs(seenbuff,chan);         /* write out last line */
              (void)fputc(0,chan);                /* and a nul */
            }
            break;                                /* end of linked list */
          }
          if (seenbuff[0] == '\0')                /* start a new line */
          {
            (void)strcpy(seenbuff,"\x01PATH:");
            cnet = 0;
          }
          if (cnet == seen->net)                  /* if same net, add node */
            (void)sprintf(tempbuff," %d",seen->node);
          else
          {                                  /* if not, add net/node */
            (void)sprintf(tempbuff," %d/%d",seen->net,seen->node);
            cnet = seen->net;
          }
          (void)strcat(seenbuff,tempbuff);

          seen = seen->next_ptr;               /* next entry */
        }
        add_to_packets(chan, areaname, msgid); /* put msg into outbound packets */
        (void)fclose(chan);
        (void)remove(filename);         /* delete file when done */
        retval = 0;                     /* return success */
      }
      free_list(feed_ptr);              /* free the linked lists */
      free_list(seen_ptr);
      free_list(path_ptr);
      return(retval);
}
/*---------------------------------------------------------------------------*/
long readstring(FILE *fp, char *ans, size_t sz) /* fetch a nul term string   */
{
  char *ptr;
  size_t count = 0;

  ptr = ans;
  while (count < sz)
  {
   *ptr = (char)fgetc(fp);
   if (*ptr == '\0')
      break;
   ptr++;
   count++;
  }
  return(count);
}
/*---------------------------------------------------------------------------*/
void log(char *msg)
{
   (void)puts(msg);
   if(lg != NULL)
   {
     (void)fputs(msg,lg);
     (void)fputs("\n",lg);
   }
}
/*---------------------------------------------------------------------------*/
void sysvar(char *varname, char *ans, int sz)
{
char msg[102];
void *a;
short rlen;

  (void)strcpy(msg,"sysvar ");
  (void)strcat(msg,varname);

  a=Request ("pbox", msg, (short)strlen(msg), &rlen);
  if (a == NULL)
    ans[0] = '\0';
  else
  {
    if (rlen < sz) sz = rlen;
    (void)strncpy(ans,a,sz);
    ans[sz] = '\0';
    free(a);
  }
}
/*---------------------------------------------------------------------------*/
int copyfile(char *s, char *t)
{
        /*----------------------------------------------------------
                       Copy file from s to file t
          ----------------------------------------------------------*/

FILE    *ip,*op;
int     c;

  ip = fopen(s,"r");    /* open source */
  if(ip == NULL)
  {
    (void)strcpy(logmsg,"Error opening ");
    (void)strcat(logmsg,s);
    log(logmsg);
    return(-1);                 /* return if error */
  }
  op = fopen(t,"w");         /* open new target */
  if(op == NULL)
  {
    (void)strcpy(logmsg,"Error opening ");
    (void)strcat(logmsg,t);
    log(logmsg);
    (void)fclose(ip);           /* close input     */
    return(-1);                 /* return if error */
  }
  while ((c = fgetc(ip)) != EOF)
    (void)fputc(c,op);

  (void)fclose(ip);
  (void)fclose(op);

return(0);
}

/*------------------------------- END ---------------------------------------*/
