#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <qdos.h>
#include <qptr.h>

#define LINES   14
#define COLUMNS 50
#define BORDERW 1
#undef _condetails
struct WINDOWDEF _condetails = {
                             2,
                             BORDERW,
                             0,
                             7,
                             6*COLUMNS+4*BORDERW,
                             10*LINES+3*BORDERW+12,
                             16,
                             26
                            };
struct INDEX_ENTRY{
char    type;
char    spare;
short   zone;
short   net;
long    filepos;
};
void    consetup_title();
void    (*_consetup)() = consetup_title;
long    (*_cmdchannels)() = NULL;
char    *_endmsg = NULL;

char    _prog_name[] = "IndexNL";
char    _version[]   = "v1.01";
char    _copyright[] = "PA Borman, May 95";

void    goodbye(int);

  FILE *nl;
  int  ix;

int  main(int argc, char * argv[], char * argp[])
{
  struct INDEX_ENTRY index;
  char nodelist[36];
  char nlindex[36];
  char entry[200];
  char *c;
  char *tokptr;
  int  nodes = 0;
  int  nets  = 0;
  int  zones = 0;

  printf("This program takes a standard IFNA nodelist\n");
  printf("and produces an index for it to make nodelist\n");
  printf("accesses faster.\n\n");
  printf("The index entries are 10 bytes per zone or net\n");
  printf("in the format\n");
  printf("Type(byte), spare(byte), Zone(word), Net(word), Position(long)\n\n");

  if (argc > 2 )
    {
      printf("usage: nodelist\n");
      goodbye(-1);
    }
  if (argc == 2 )
    strcpy(nodelist,argv[1]);
  else
  {
    printf("Nodelist to index -> ");
    scanf("%s\n",nodelist);
  }
  nl = fopen(nodelist,"r");
  if (nl != NULL)
  {
    strcpy(nlindex,nodelist);
    c = nlindex;
    c += strlen(nlindex);
    c -= 3;
    strcpy(c,"idx");
    ix = creat(nlindex,O_RDWR);
    if ( ix != -1 )
    {
      (void)write(ix, nodelist, strlen(nodelist));
      (void)write(ix, "\n", 1);         /* write nodelist name into file */
      index.spare = '\0';
      do
      {
        index.filepos = ftell(nl);
        c = fgets(entry,200,nl);
        index.type = *((char *)entry);
        if (strstr(entry,"Zone") == entry)
        {
          tokptr = strtok(entry, ",");
          tokptr = strtok(NULL, ",");
          index.zone = (short)atoi(tokptr);
          index.net = 0;
          write( ix, (char *)&index, sizeof(struct INDEX_ENTRY));
          printf("Zone %d : %s\n",index.zone,strtok(NULL, ","));
          zones++;
        }
        else
        {
          if (strstr(entry,"Host") == entry)
          {
            tokptr = strtok(entry, ",");
            tokptr = strtok(NULL, ",");
            index.net = (short)atoi(tokptr);
            write( ix, (char *)&index, sizeof(struct INDEX_ENTRY));
            printf("   %4.4d %s\n",index.net,strtok(NULL, ","));
            nets++;
          }
          else
          {
            if (strstr(entry,",") == entry)
            {
              nodes++;
            }
          }
        }
      } while (c != NULL);

      printf("Found %d zones,  %d nets,  %d nodes\n",
             zones,nets,nodes);
      goodbye(0);
    }
    else
    {
      printf("Unable to open %s\nProgram aborted.",nlindex);
      goodbye(-1);
    }
  }
  else
  {
    printf("Unable to open %s\nProgram aborted.",nodelist);
    goodbye(-1);
  }
}
void goodbye(int exit_code)
{
   if( nl != NULL)
     fclose(nl);
   if( ix != -1);
     close(ix);
   sleep(4);
   exit(exit_code);
}
